"use strict";
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
function createSwagger(schema, plugins) {
    return Promise.resolve().then(function () { return tslib_1.__importStar(require("swagger-ui-dist")); }).then(function (swagger) {
        var presets = [swagger.SwaggerUIBundle.presets.apis, plugins];
        var ui = swagger.SwaggerUIBundle({
            dom_id: "#swagger",
            spec: schema,
            presets: presets,
            requestInterceptor: function (req) {
                var bearer = localStorage.getItem("bearer");
                req.headers = tslib_1.__assign({}, req.headers, { Authorization: bearer });
                return req;
            },
        });
        return ui;
    });
}
function prepareDataForCreate(schema, url) {
    if (url) {
        schema = tslib_1.__assign({}, schema, { host: url });
    }
    return schema;
}
exports.OpenApiRenderEngine = function (_a) {
    var source = _a.source, _b = _a.options, options = _b === void 0 ? {} : _b;
    react_1.useEffect(function () {
        var create = function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, createSwagger(prepareDataForCreate(source.content || source.rawContent, (source.data && source.data.url) || options.schemaUrl), options.plugins)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        create();
    }, [source, options]);
    return react_1.default.createElement("div", { id: "swagger" });
};
